From 3d2ef674a41e25e0546524a8c02a9ae26c7338e5 Mon Sep 17 00:00:00 2001
From: David Tolnay <dtolnay@gmail.com>
Date: Dec 29 2020 05:04:11 +0000
Subject: [PATCH 1851/2232] Add lifetimes to ExternType and TypeAlias syntax tree


---

diff --git a/gen/src/nested.rs b/gen/src/nested.rs
index abc9670..99cfdf8 100644
--- a/gen/src/nested.rs
+++ b/gen/src/nested.rs
@@ -136,6 +136,7 @@ mod tests {
                 cxx: ident.clone(),
                 rust: ident,
             },
+            lifetimes: Vec::new(),
             colon_token: None,
             bounds: Vec::new(),
             semi_token: Token![;](Span::call_site()),
diff --git a/syntax/mod.rs b/syntax/mod.rs
index 111cec3..c878ae2 100644
--- a/syntax/mod.rs
+++ b/syntax/mod.rs
@@ -74,6 +74,7 @@ pub struct ExternType {
     pub derives: Vec<Derive>,
     pub type_token: Token![type],
     pub name: Pair,
+    pub lifetimes: Vec<Lifetime>,
     pub colon_token: Option<Token![:]>,
     pub bounds: Vec<Derive>,
     pub semi_token: Token![;],
@@ -115,6 +116,7 @@ pub struct TypeAlias {
     pub derives: Vec<Derive>,
     pub type_token: Token![type],
     pub name: Pair,
+    pub lifetimes: Vec<Lifetime>,
     pub eq_token: Token![=],
     pub ty: RustType,
     pub semi_token: Token![;],
diff --git a/syntax/parse.rs b/syntax/parse.rs
index 1ae4c2d..0cbb2aa 100644
--- a/syntax/parse.rs
+++ b/syntax/parse.rs
@@ -385,6 +385,7 @@ fn parse_extern_type(
 
     let type_token = foreign_type.type_token;
     let name = pair(namespace, &foreign_type.ident, cxx_name, rust_name);
+    let lifetimes = Vec::new();
     let colon_token = None;
     let bounds = Vec::new();
     let semi_token = foreign_type.semi_token;
@@ -398,6 +399,7 @@ fn parse_extern_type(
         derives,
         type_token,
         name,
+        lifetimes,
         colon_token,
         bounds,
         semi_token,
@@ -632,12 +634,14 @@ fn parse_type_alias(
     }
 
     let name = pair(namespace, &ident, cxx_name, rust_name);
+    let lifetimes = Vec::new();
 
     Ok(Api::TypeAlias(TypeAlias {
         doc,
         derives,
         type_token,
         name,
+        lifetimes,
         eq_token,
         ty,
         semi_token,
@@ -704,6 +708,7 @@ fn parse_extern_type_bounded(
     );
 
     let name = pair(namespace, &ident, cxx_name, rust_name);
+    let lifetimes = Vec::new();
     let colon_token = Some(colon_token);
 
     Ok(match lang {
@@ -715,6 +720,7 @@ fn parse_extern_type_bounded(
         derives,
         type_token,
         name,
+        lifetimes,
         colon_token,
         bounds,
         semi_token,

